"""

    Iterator class for TAL scripts
    
    Copyright 2006 Mikko Ohtamaa


"""

class StepIterator:
    """ Iterator class which increases index variable amount on each cycle
    
    This is needed for forms utilizing DataGridWidget.
    You need to add "empty tabindex space" between form widgets
    so that DataGridWidget can get tabindexes for dynamically 
    created rows.            
    """
    
    __allow_access_to_unprotected_subobjects__ = True
    
    def __init__(self, upper=100000, pos=0, step=1):
        self.upper=upper
        self.pos=pos
        self.step = step
        # would cause problems...
        assert step > 0

    def next(self):
        if self.pos <= self.upper:
            self.pos += self.step
            return self.pos
        raise KeyError, 'Reached upper bounds'
