"""
    Archetypes items used in DataGridField unit testing and examples
    
"""
# Zope imports
from AccessControl import ClassSecurityInfo

# Plone imports
from Products.Archetypes.public import DisplayList
from Products.Archetypes.public import *

# Local imports
from Products.DataGridField import DataGridField, DataGridWidget
from Products.DataGridField.Column import Column
from Products.DataGridField.SelectColumn import SelectColumn

class DataGridDemoType(BaseContent):
    """A simple archetype
    
    This class is used in unit testing
    """
    security = ClassSecurityInfo()
    
    schema = BaseSchema + Schema((

        DataGridField('DemoField',
                widget = DataGridWidget(),
                columns=('column1','column2','The third')
                ),
        ))
        
    meta_type = portal_type = archetype_name = 'DataGridDemoType'
    
registerType(DataGridDemoType)    

class DataGridDemoType2(BaseContent):
    """A simple archetype 
    
    This class is used in unit testing
    """
    security = ClassSecurityInfo()
    
    schema = BaseSchema + Schema((
        DataGridField('DemoField',
                searchable = True,
                columns=("column1", "column2", "select_sample"),
                widget = DataGridWidget(
                    columns={
                        'column1' : Column("Toholampi city rox"),
                        'column2' : Column("My friendly name"),
                        'select_sample' : SelectColumn("Friendly name", vocabulary="getSampleVocabulary")
                    },
                 ),
         ),
                
        ))
    
    meta_type = portal_type = archetype_name = 'DataGridDemoType2'
    
    def getSampleVocabulary(self):
        """
        """
        """ Get list of possible taggable features from ATVocabularyManager """  
        return DisplayList(
    
            (("sample", "Sample value 1",),
            ("sample2", "Sample value 2",),))

registerType(DataGridDemoType2)

class InvalidDataGridDemoType(BaseContent):
    """ This class is missing column definition select_sample in DataGridWidget
        
    """
    security = ClassSecurityInfo()
    
    schema = BaseSchema + Schema((
        DataGridField('DemoField',
                searchable = True,
                columns=("column1", "column2", "select_sample"),
                widget = DataGridWidget(
                    columns={
                        'column1' : Column("Toholampi city rox"),
                        'column2' : Column("My friendly name"),
                    },                 
          ),),
                
        ))
    
    meta_type = portal_type = archetype_name = 'InvalidDataGridDemoType'        

registerType(InvalidDataGridDemoType)

